from json import JSONEncoder
import json
from datetime import datetime
from iip.TypeTranslatorToString import TypeTranslatorToString
import Registry
from datatypes.RoutingTestData import RoutingTestData
from datatypes.RoutingTestDataImpl import RoutingTestDataImpl

class RoutingTestDataEncoder(JSONEncoder):
    """JSON encoder class for RoutingTestData.
    Generated by: EASy-Producer."""

    def default(self, o):
        """Provides access to the attributes in o.
        
        Parameters:
          - o -- the object to serialize
        Returns:
          dict
            the attributes
        """
        return o.__dict__
    

class RoutingTestDataSerializer(TypeTranslatorToString):
    """JSON transport serializer for RoutingTestData.
       Generated by: EASy-Producer."""
                
    def __init__(self):
        """Initializes the transformer.""" 
        Registry.serializers["RoutingTestData"] = self
        Registry.types[RoutingTestData] = "RoutingTestData"
        Registry.serializers["RoutingTestDataImpl"] = self # there is a serializer for the Impl
        Registry.types[RoutingTestDataImpl] = "RoutingTestData" # the Impl maps back to the type name
    
    def readFrom(self, data: str) -> RoutingTestData:
        """Turns bytes into a String.
        
        Parameters:
          - data -- the data string
        Returns:
          object
            the deserialized object
        """
    
        result = RoutingTestDataImpl()
        result.__dict__ = json.loads(data)
        return result

    def writeTo(self, source: RoutingTestData) -> str:
        """Turns an object into a String.
        
        Parameters:
          - source -- the object
        Returns:
          bytes
            the serialized data string
        """
        
        return RoutingTestDataEncoder().encode(source).encode("UTF-8").decode()
        
RoutingTestDataSerializer()
